import { LocationLike, Time, Currency, RecurrentTimeRule } from './values';
export declare function distance(a: LocationLike, b: LocationLike): number;
export declare function equality(a: unknown, b: unknown): boolean;
export declare function like(a_: unknown, b: string): boolean;
export declare function startsWith(a: unknown, b: unknown): boolean;
export declare function endsWith(a: unknown, b: unknown): boolean;
export declare function recurrentTimeSpecContains(spec: RecurrentTimeRule[], timeOrDate: Date | Time): boolean;
export declare function contains(a: unknown[], b: unknown): boolean;
export declare function containsLike(a: unknown[], b: string): boolean;
export declare function inArrayLike(a: string, b: string[]): boolean;
export declare function getTime(d: Date): Time;
export declare function getCurrency(d: number): Currency;
export declare function sum(a: number, b: number): number;
export declare function max(a: number, b: number): number;
export declare function min(a: number, b: number): number;
export declare function argmax(value: number, previous: number): boolean;
export declare function argmin(value: number, previous: number): boolean;
export declare class EqualitySet {
    store: unknown[];
    constructor();
    has(value: unknown): boolean;
    add(value: unknown): void;
    get size(): number;
}
declare type ArgMinMaxOp = (value: number, previous: number) => number;
export declare class ArgMinMaxState<T> {
    private _op;
    private _field;
    private _total;
    private _filled;
    private _tuples;
    private _outputTypes;
    private _base;
    constructor(op: ArgMinMaxOp, field: keyof T, base: number, limit: number);
    [Symbol.iterator](): Generator<[string, unknown], void>;
    update(tuple: T, outputType: string): void;
}
export declare function count(x: unknown[]): number;
export declare function aggregateMax(array: number[]): number;
export declare function aggregateMin(array: number[]): number;
export declare function aggregateSum(array: number[]): number;
export declare function aggregateAvg(array: number[]): number;
export declare function dateAdd(date: Date, offset: number): Date;
export declare function dateSub(date: Date, offset: number): Date;
export declare function timeAdd(time: Time, offset: number): Time;
export declare function timeSub(time: Time, offset: number): Time;
export {};
