import * as Ast from './ast';
import * as I18n from './i18n';
declare type ScopeMap = {
    [key: string]: string;
};
declare class Describer {
    private _;
    locale: string;
    timezone: string | undefined;
    private _format;
    private _interp;
    constructor(gettext?: I18n.Gettext, locale?: string, timezone?: string);
    private _displayLocation;
    private _describeTime;
    private _describeDate;
    describeArg(arg: Ast.Value, scope?: ScopeMap): string;
    private _describeArg;
    private _describeOperator;
    private _compoundTypeToSchema;
    private _describeAtomFilter;
    describeFilter(expr: Ast.BooleanExpression, schema?: Ast.ExpressionSignature | null, scope?: ScopeMap, canonical_overwrite?: ScopeMap): string;
    private _getDeviceAttribute;
    describePrimitive(obj: Ast.Invocation | Ast.ExternalBooleanExpression, scope?: ScopeMap, extraInParams?: Ast.InputParam[]): string;
    private _describeIndex;
    private _describeFilteredTable;
    describeTable(table: Ast.Table, extraInParams?: Ast.InputParam[]): string;
    private __describeArgList;
    describeStream(stream: Ast.Stream): string;
    private _describeNotifyAction;
    private _describeAction;
    private _describeActionList;
    private _describeRule;
    private _describeAssignment;
    describeProgram(program: Ast.Program): string;
    describePermissionFunction(permissionFunction: Ast.PermissionFunction, functionType: 'query' | 'action', scope: ScopeMap): string;
    describePermissionRule(permissionRule: Ast.PermissionRule): string;
    private _describeSpecial;
    private _describeControlCommand;
    describe(input: Ast.Input): string;
}
declare function pubGetProgramName(gettext: I18n.Gettext, program: Ast.Program): string;
declare function pubDescribeArg(gettext: I18n.Gettext, arg: Ast.Value, scope?: ScopeMap): string;
declare function pubDescribeFilter(gettext: I18n.Gettext, filter: Ast.BooleanExpression, schema: Ast.ExpressionSignature, scope?: ScopeMap): string;
declare function pubDescribeProgram(gettext: I18n.Gettext, program: Ast.Program): string;
declare function pubDescribePrimitive(gettext: I18n.Gettext, prim: Ast.Invocation, scope: ScopeMap): string;
declare function pubDescribeStream(gettext: I18n.Gettext, stream: Ast.Stream): string;
declare function pubDescribeTable(gettext: I18n.Gettext, table: Ast.Table, extraInParams?: Ast.InputParam[]): string;
declare function pubDescribePermissionRule(gettext: I18n.Gettext, permissionRule: Ast.PermissionRule): string;
declare function pubDescribePermissionFunction(gettext: I18n.Gettext, permissionFunction: Ast.PermissionFunction, functionType: 'query' | 'action', scope: ScopeMap): string;
export { Describer, pubDescribeArg as describeArg, pubDescribeFilter as describeFilter, pubDescribeProgram as describeProgram, pubDescribePrimitive as describePrimitive, pubDescribeStream as describeStream, pubDescribeTable as describeTable, pubDescribePermissionRule as describePermissionRule, pubDescribePermissionFunction as describePermissionFunction, pubGetProgramName as getProgramName };
